import threading
import socket
import errno

from stomp.const import ERROR
from stomp.const import RECEIPT
from stomp.const import CONNECTED
from stomp.const import DISCONNECT
from stomp.utils import parse_raw_frames
from stomp.utils import parse_receipt_id


class Connection(object):
    """Represents a connection to the STOMP server."""
    default_chunk_size = 1024**2
    default_timeout = 10000

    def __init__(self, chunk_size=None):
        self._recv_thread = threading.Thread(target=self.__main_event_loop)
        self._recv_thread.daemon = True
        self._buffer = ''
        self._frames = []
        self._chunk_size = chunk_size or self.default_chunk_size

        # Setup the socket
        self._socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self._socket.settimeout((timeout or self.default_timeout) / 1000)

    def __main_event_loop(self):
        # Receive data from the STOMP server and put it in a buffer.
        while True:
            self._socket._setblocking(0)
            try:
                chunk = self._socket.recv()
            except Exception as e:
                if not hasattr(e, 'errno'):
                    raise
                if e.errno not in (errno.EAGAIN, errno.EINTR):
                    raise
                continue
            
            # Parse the raw frame and asses what to do with it.


